import java.util.Collection;
import java.util.Date;

import javax.persistence.EntityManager;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public void updateProfessor(Professor emp) {
    if (em.find(Professor.class, emp.getId()) == null) {
      throw new IllegalArgumentException("Unknown employee id: " + emp.getId());
    }
    Professor managedEmp = em.merge(emp);
    managedEmp.setLastAccessTime(new Date());
  }

  public void updateProfessorIncorrect(Professor emp) {
    if (em.find(Professor.class, emp.getId()) == null) {
      throw new IllegalArgumentException("Unknown employee id: " + emp.getId());
    }
    em.merge(emp);
    emp.setLastAccessTime(new Date());
  }

  public Collection<Professor> findAllProfessors() {
    return (Collection<Professor>) em.createQuery("SELECT e FROM Professor e").getResultList();
  }
}
